<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 26/06/19
 * Time: 12.53
 */

namespace FiloBlu\Rma\Model\ResourceModel\Rma;


class Collection extends \Magento\Framework\Model\ResourceModel\Db\Collection\AbstractCollection
{
    /**
     * Resource initialization.
     */
    ///protected $_idFieldName = 'entity_id';

    protected $_eventPrefix = 'filoblu_rma_rma_grid_collection';

    protected $_eventObject = 'filoblu_rma_rma_collection';


    /**
     * Collection constructor.
     * @param \Magento\Framework\Data\Collection\EntityFactoryInterface $entityFactory
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Magento\Framework\Data\Collection\Db\FetchStrategyInterface $fetchStrategy
     * @param \Magento\Framework\Event\ManagerInterface $eventManager
     * @param \Magento\Framework\DB\Adapter\AdapterInterface|null $connection
     * @param \Magento\Framework\Model\ResourceModel\Db\AbstractDb|null $resource
     */
    public function __construct(\Magento\Framework\Data\Collection\EntityFactoryInterface $entityFactory, \Psr\Log\LoggerInterface $logger, \Magento\Framework\Data\Collection\Db\FetchStrategyInterface $fetchStrategy, \Magento\Framework\Event\ManagerInterface $eventManager, \Magento\Framework\DB\Adapter\AdapterInterface $connection = null, \Magento\Framework\Model\ResourceModel\Db\AbstractDb $resource = null)
    {
          $this->_init('FiloBlu\Rma\Model\Rma','FiloBlu\Rma\Model\ResourceModel\Rma');
          parent::__construct($entityFactory, $logger, $fetchStrategy, $eventManager, $connection, $resource);
    }

    /**
     * @return \Magento\Framework\Model\ResourceModel\Db\Collection\AbstractCollection|void
     */
    protected function _initSelect()
    {
        parent::_initSelect()->addFieldToSelect(['order_id','order_increment_id','customer_name'])->getSelect()->joinLeft(
            ['magento_rma_status_history' => $this->getTable('magento_rma_status_history')],
            'main_table.entity_id = magento_rma_status_history.rma_entity_id',
            [
                'comment'=>'magento_rma_status_history.comment',
                'status'=>'magento_rma_status_history.status',
                'created_at'=>'magento_rma_status_history.created_at',
                'rma_entity_id' =>'magento_rma_status_history.rma_entity_id'
            ]
        );
        $this->addFilterToMap('comment', 'magento_rma_status_history.comment');
        $this->addFilterToMap('status', 'magento_rma_status_history.status');
        $this->addFilterToMap('created_at', 'magento_rma_status_history.created_at');
        $this->addFilterToMap('rma_entity_id', 'magento_rma_status_history.rma_entity_id');
       // return $this;
    }


    public function getSelectCountSql()
    {
        $countSelect = parent::getSelectCountSql();
        $countSelect->reset(\Zend_Db_Select::GROUP);
        return $countSelect;
    }

    protected function _toOptionArray($valueField = 'entity_id', $labelField = 'entity_id', $additional = [])
    {
        return parent::_toOptionArray($valueField, $labelField, $additional);
    }

    public function addFieldToSearchFilter($field, $condition = null)
    {
        $field = $this->_getMappedField($field);
        $this->_select->orWhere($this->_getConditionSql($field, $condition));
        return $this;
    }



}